package com.bcxin.tenant.open.domains.mappers;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.bcxin.tenant.open.domains.entities.MonthlyBillEntity;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public interface MonthlyBillMapper extends BaseMapper<MonthlyBillEntity> {

    /**
     * 月度账单生成时
     * @param bills
     */
    void generateBills(List<MonthlyBillEntity> bills);

    /**
     * 插入空账单，在日账单需要关联月度账单时使用
     * @param bills
     */
    void insertEmptyBills(List<MonthlyBillEntity> bills);

    void updatePaidAmount(List<MonthlyBillEntity> bills);
}
