package com.bcxin.tenant.open.domains.mappers;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.bcxin.tenant.open.domains.dtos.ProcessTencentCallbackLogDTO;
import com.bcxin.tenant.open.domains.entities.TencentCallbackLogEntity;
import com.bcxin.tenant.open.domains.views.TencentCallbackLogView;
import com.bcxin.tenant.open.domains.views.TencentNoReplyUserView;
import org.springframework.stereotype.Component;

import java.util.Collection;

@Component
public interface TencentCallbackLogMapper extends BaseMapper<TencentCallbackLogEntity> {
    Collection<String> getTopExitRoomButPendingIds(Collection<Long> exitRoomLogIds);

    Collection<TencentCallbackLogView> getAllPendingLogsByRoomIds(Collection<Long> roomIds);

    void process(ProcessTencentCallbackLogDTO callbackLogDTO);

    void customInsert(TencentCallbackLogEntity entity);

    Collection<Long> getTopReadyTencentClosedRoomEventIds(int page);

    Collection<TencentNoReplyUserView> getAllNoReplyUsers(Collection<Long> roomIds);
}
