package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.ConfigOfBillEntity;
import com.bcxin.tenant.open.domains.mappers.ConfigOfBillMapper;
import com.bcxin.tenant.open.infrastructures.exceptions.NoImplementTenantException;
import com.bcxin.tenant.open.infrastructures.models.CacheData;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Repository
public class ConfigOfBillRepositoryImpl implements ConfigOfBillRepository {
    private static final Logger logger = LoggerFactory.getLogger(ConfigOfBillRepositoryImpl.class);
    private final ConfigOfBillMapper configOfBillMapper;

    public ConfigOfBillRepositoryImpl(ConfigOfBillMapper configOfBillMapper) {
        this.configOfBillMapper = configOfBillMapper;
    }

    @Override
    public ConfigOfBillEntity getById(Object id) {
        throw new NoImplementTenantException();
    }

    @Override
    public void insert(ConfigOfBillEntity data) {
        throw new NoImplementTenantException();
    }

    @Override
    public void update(ConfigOfBillEntity data) {
        throw new NoImplementTenantException();
    }


    private static CacheData<ConfigOfBillEntity> _cachedConfigData =null;
    @Override
    public ConfigOfBillEntity get() {
        if (_cachedConfigData == null || _cachedConfigData.IsExpired()) {
            List<ConfigOfBillEntity> data = null;
            try {
                LambdaQueryWrapper<ConfigOfBillEntity> lambdaQueryWrapper = new LambdaQueryWrapper<>();
                data = this.configOfBillMapper.selectList(lambdaQueryWrapper);
            } catch (Exception ex) {
                logger.error("获取联动值消耗配置异常", ex);
            }

            if (CollectionUtils.isEmpty(data)) {
                return ConfigOfBillEntity.getDefault();
            }

            /**
             * 缓存10分钟
             */
            _cachedConfigData = CacheData.create(data.get(0), 10 * 60);
        }

        return _cachedConfigData.getData();
    }
}
