package com.bcxin.tenant.open.domains.repositories;

import com.bcxin.tenant.open.domains.entities.DailyBillEntity;
import com.bcxin.tenant.open.domains.mappers.DailyBillMapper;
import com.bcxin.tenant.open.domains.pojo.DailyBillPojo;
import com.bcxin.tenant.open.domains.pojo.MonthBillPojo;
import com.bcxin.tenant.open.infrastructures.enums.BillType;
import org.springframework.stereotype.Repository;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Repository
public class DailyBillRepositoryImpl implements DailyBillRepository {
    private DailyBillMapper billMapper;

    public DailyBillRepositoryImpl(DailyBillMapper billMapper) {
        this.billMapper = billMapper;
    }

    @Override
    public DailyBillEntity getById(Object id) {
        return null;
    }

    @Override
    public void insert(DailyBillEntity billEntity) {
        this.billMapper.insert(billEntity);
    }

    @Override
    public void update(DailyBillEntity data) {

    }

    @Override
    public void insert(List<DailyBillEntity> dailyBillEntityList) {
        this.billMapper.insertList(dailyBillEntityList);
    }

    @Override
    public List<MonthBillPojo> calcMonthBill(String date, BillType type) {
        return this.billMapper.calcMonthBill(date, type.ordinal());
    }

    @Override
    public List<DailyBillPojo> getAttendanceBillInfo(String orgId, Date fromDate, Date endDate) {

        return this.billMapper.getAttendanceBillInfo(
                orgId,
                fromDate == null ? null : new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(fromDate),
                new SimpleDateFormat("yyyy-MM-dd 23:59:59").format(endDate));
    }

    @Override
    public List<DailyBillPojo> getRollCallBillInfo(String orgId, Date fromDate, Date endDate) {
        return this.billMapper.getRollCallBillInfo(orgId,
                fromDate == null ? null : new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(fromDate),
                new SimpleDateFormat("yyyy-MM-dd 23:59:59").format(endDate));
    }

    @Override
    public List<DailyBillPojo> getEmployeeLocationBillInfo(String orgId, Date fromDate, Date endDate) {
        return this.billMapper.getEmployeeLocationBillInfo(
                orgId,
                fromDate == null ? null : new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(fromDate),
                new SimpleDateFormat("yyyy-MM-dd 23:59:59").format(endDate));
    }

    @Override
    public List<DailyBillPojo> getSecurityStationRailBillInfo(String orgId, Date fromDate, Date endDate) {
        return this.billMapper.getSecurityStationRailBillInfo(
                orgId,
                fromDate == null ? null : new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(fromDate),
                new SimpleDateFormat("yyyy-MM-dd 23:59:59").format(endDate));
    }

    @Override
    public List<MonthBillPojo> calcMonthBillRange(String orgId, BillType type, Date fromDate, Date endDate) {
        return this.billMapper.calcMonthBillByRange(
                orgId,
                type.ordinal(),
                fromDate == null ? null : new SimpleDateFormat("yyyy-MM-dd 00:00:00").format(fromDate),
                new SimpleDateFormat("yyyy-MM-dd 23:59:59").format(endDate));
    }
}
