package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.bcxin.tenant.open.domains.entities.OrgPurseEntity;
import com.bcxin.tenant.open.domains.mappers.OrgPurseMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.io.Serializable;
import java.util.Collection;
import java.util.Collections;

@Repository
public class OrgPurseRepositoryImpl implements OrgPurseRepository {
    private final OrgPurseMapper orgPurseMapper;

    public OrgPurseRepositoryImpl(OrgPurseMapper orgPurseMapper) {
        this.orgPurseMapper = orgPurseMapper;
    }


    @Override
    public OrgPurseEntity getById(Object id) {
        return this.orgPurseMapper.selectById((Serializable) id);
    }

    @Override
    public void insert(OrgPurseEntity data) {
        this.orgPurseMapper.insert(data);
    }

    @Override
    public void update(OrgPurseEntity data) {
        this.orgPurseMapper.updateById(data);
    }

    @Override
    public Collection<OrgPurseEntity> getByOrganizationIds(Collection<String> organizationIds) {
        if (CollectionUtils.isEmpty(organizationIds)) {
            return Collections.EMPTY_LIST;
        }

        LambdaQueryWrapper<OrgPurseEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.in(OrgPurseEntity::getOrganizationId, organizationIds);

        return orgPurseMapper.selectList(queryWrapper);
    }

    @Override
    public int update(OrgPurseEntity orgPurseEntity, LambdaUpdateWrapper updateWrapper) {
        return this.orgPurseMapper.update(orgPurseEntity,updateWrapper);
    }
}
