package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.OrgPurseEntity;
import com.bcxin.tenant.open.domains.entities.OrgPurseTransactionEntity;
import com.bcxin.tenant.open.domains.mappers.OrgPurseMapper;
import com.bcxin.tenant.open.domains.mappers.OrgPurseTransactionMapper;
import com.bcxin.tenant.open.infrastructures.exceptions.RetryableTenantException;
import org.apache.ibatis.session.ExecutorType;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;
import java.util.Optional;
import java.util.stream.Collectors;

@Repository
public class OrgPurseTransactionRepositoryImpl implements OrgPurseTransactionRepository {
    private final OrgPurseTransactionMapper purseTransactionMapper;
    private final OrgPurseMapper orgPurseMapper;
    private final SqlSessionFactory sessionFactory;

    public OrgPurseTransactionRepositoryImpl(OrgPurseTransactionMapper purseTransactionMapper,
                                             OrgPurseMapper orgPurseMapper,
                                             SqlSessionFactory sessionFactory) {
        this.purseTransactionMapper = purseTransactionMapper;
        this.orgPurseMapper = orgPurseMapper;
        this.sessionFactory = sessionFactory;
    }

    @Override
    public OrgPurseTransactionEntity getById(Object id) {
        return null;
    }

    @Override
    public void insert(OrgPurseTransactionEntity data) {
        purseTransactionMapper.insert(data);
    }

    @Override
    public void update(OrgPurseTransactionEntity data) {

    }

    @Override
    public void batchInsert(Collection<OrgPurseTransactionEntity> transactions) {
        if (CollectionUtils.isEmpty(transactions)) {
            return;
        }

        this.orgPurseMapper.customInsert(transactions);
    }

    @Override
    public void batchInsertWithoutUpdateOrgPurse(Collection<OrgPurseTransactionEntity> transactions) {
        if(transactions.isEmpty()){
            return;
        }
        this.purseTransactionMapper.batchInsert(transactions);
    }
}
