package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bcxin.tenant.open.domains.entities.RdCommunityUserEntity;
import com.bcxin.tenant.open.domains.mappers.RdCommunityUserMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class RdCommunityUserRepositoryImpl implements RdCommunityUserRepository{

    private final RdCommunityUserMapper communityUserMapper;

    public RdCommunityUserRepositoryImpl(RdCommunityUserMapper communityUserMapper) {
        this.communityUserMapper = communityUserMapper;
    }


    @Override
    public RdCommunityUserEntity getById(Object id) {
        return this.communityUserMapper.selectById((Long)id);
    }

    @Override
    public void insert(RdCommunityUserEntity data) {
        this.communityUserMapper.insert(data);
    }

    @Override
    public void update(RdCommunityUserEntity data) {
        this.communityUserMapper.updateById(data);
    }

    @Override
    public Collection<RdCommunityUserEntity> getByPage(Collection<String> ids, int pageIndex, int pageSize) {
        LambdaQueryWrapper<RdCommunityUserEntity> wrapper = new LambdaQueryWrapper();
        if (pageIndex <= 0) {
            pageIndex = 1;
        }

        if (!CollectionUtils.isEmpty(ids)) {
            wrapper = wrapper.in(RdCommunityUserEntity::getId, ids);
        }

        IPage<RdCommunityUserEntity> page = new Page<>(pageIndex, pageSize);

        IPage<RdCommunityUserEntity> communityUserEntityPage =
                this.communityUserMapper.selectPage(page, wrapper);

        return communityUserEntityPage.getRecords();
    }
}
