package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.RdDeviceLocationHistoryEntity;
import com.bcxin.tenant.open.domains.entities.TenantEmployeeAttendanceEntity;
import com.bcxin.tenant.open.domains.mappers.RdDeviceLocationHistoryMapper;
import org.springframework.stereotype.Repository;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;

@Repository
public class RdDeviceLocationHistoryRepositoryImpl implements RdDeviceLocationHistoryRepository {
    private final RdDeviceLocationHistoryMapper deviceLocationHistoryMapper;

    public RdDeviceLocationHistoryRepositoryImpl(RdDeviceLocationHistoryMapper deviceLocationHistoryMapper) {
        this.deviceLocationHistoryMapper = deviceLocationHistoryMapper;
    }

    @Override
    public RdDeviceLocationHistoryEntity getById(Object id) {
        return this.deviceLocationHistoryMapper.selectById((Serializable) id);
    }

    @Override
    public void insert(RdDeviceLocationHistoryEntity data) {
        this.deviceLocationHistoryMapper.insert(data);
    }

    @Override
    public void update(RdDeviceLocationHistoryEntity data) {
        this.deviceLocationHistoryMapper.updateById(data);
    }

    @Override
    public Collection<RdDeviceLocationHistoryEntity> getLocations(String deviceId, Date beginDate, Date endDate) {
        LambdaQueryWrapper<RdDeviceLocationHistoryEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper = queryWrapper.eq(RdDeviceLocationHistoryEntity::getDeviceId, deviceId);
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        if (beginDate != null) {
            queryWrapper = queryWrapper.ge(RdDeviceLocationHistoryEntity::getCreatedTime, dateFormat.format(beginDate));
        }
        if (endDate != null) {
            queryWrapper = queryWrapper.lt(RdDeviceLocationHistoryEntity::getCreatedTime, dateFormat.format(endDate));
        }

        return this.deviceLocationHistoryMapper.selectList(queryWrapper);
    }
}
