package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.RdDynamicStationTypeEntity;
import com.bcxin.tenant.open.domains.mappers.RdDynamicStationTypeMapper;
import com.bcxin.tenant.open.infrastructures.constants.BusinessConstants;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.stream.Stream;

@Repository
public class RdDynamicStationTypeRepositoryImpl implements RdDynamicStationTypeRepository{

    private final RdDynamicStationTypeMapper dynamicStationTypeMapper;

    public RdDynamicStationTypeRepositoryImpl(RdDynamicStationTypeMapper dynamicStationTypeMapper) {
        this.dynamicStationTypeMapper = dynamicStationTypeMapper;
    }

    @Override
    public RdDynamicStationTypeEntity getById(Object id) {
        return this.dynamicStationTypeMapper.selectById((String)id);
    }

    @Override
    public void insert(RdDynamicStationTypeEntity data) {
        this.dynamicStationTypeMapper.insert(data);
    }

    @Override
    public void update(RdDynamicStationTypeEntity data) {
        this.dynamicStationTypeMapper.insert(data);
    }

    @Override
    public Collection<RdDynamicStationTypeEntity> getAll(String organizationId) {
        LambdaQueryWrapper<RdDynamicStationTypeEntity> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        Collection<String> ids = Stream.of(organizationId, BusinessConstants.DefaultEmptyValue).toList();
        lambdaQueryWrapper.in(RdDynamicStationTypeEntity::getOrganizationId, ids);

        var stationTypes = this.dynamicStationTypeMapper.selectList(lambdaQueryWrapper);

        return stationTypes;
    }
}
