package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bcxin.tenant.open.domains.entities.RdExamSiteEntity;
import com.bcxin.tenant.open.domains.entities.RdSecurityStationEntity;
import com.bcxin.tenant.open.domains.mappers.RdExamSiteMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class RdExamSiteRepositoryImpl extends RdQueryEntityRepositoryAbstract<RdExamSiteEntity> implements RdExamSiteRepository{
    private final RdExamSiteMapper rdExamSiteMapper;

    public RdExamSiteRepositoryImpl(RdExamSiteMapper rdExamSiteMapper) {
        this.rdExamSiteMapper = rdExamSiteMapper;
    }

    @Override
    public Collection<RdExamSiteEntity> getByPage(Collection<String> ids, int pageIndex, int pageSize) {
        LambdaQueryWrapper<RdExamSiteEntity> wrapper = new LambdaQueryWrapper();
        if (!CollectionUtils.isEmpty(ids)) {
            wrapper = wrapper.in(RdExamSiteEntity::getId, ids);
        }

        if (pageIndex <= 0) {
            pageIndex = 1;
        }

        IPage<RdExamSiteEntity> page = new Page<>(pageIndex, pageSize);

        IPage<RdExamSiteEntity> examSiteEntityIPage =
                this.rdExamSiteMapper.selectPage(page, wrapper);

        return examSiteEntityIPage.getRecords();
    }
}
