package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bcxin.tenant.open.domains.entities.RdExamSiteRoomEntity;
import com.bcxin.tenant.open.domains.mappers.RdExamSiteRoomMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class RdExamSiteRoomRepositoryImpl extends RdQueryEntityRepositoryAbstract<RdExamSiteRoomEntity> implements RdExamSiteRoomRepository {

    private final RdExamSiteRoomMapper rdExamSiteRoomMapper;

    public RdExamSiteRoomRepositoryImpl(RdExamSiteRoomMapper rdExamSiteRoomMapper) {
        this.rdExamSiteRoomMapper = rdExamSiteRoomMapper;
    }

    @Override
    public Collection<RdExamSiteRoomEntity> getByPage(Collection<String> ids, int pageIndex, int pageSize) {
        LambdaQueryWrapper<RdExamSiteRoomEntity> wrapper = new LambdaQueryWrapper();
        if (!CollectionUtils.isEmpty(ids)) {
            wrapper = wrapper.in(RdExamSiteRoomEntity::getId, ids);
        }

        if (pageIndex <= 0) {
            pageIndex = 1;
        }

        IPage<RdExamSiteRoomEntity> page = new Page<>(pageIndex, pageSize);

        IPage<RdExamSiteRoomEntity> examSiteEntityIPage =
                this.rdExamSiteRoomMapper.selectPage(page, wrapper);

        return examSiteEntityIPage.getRecords();
    }
}
