package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.RdProjectTeamGroupEntity;
import com.bcxin.tenant.open.domains.mappers.RdProjectTeamGroupMapper;
import org.springframework.stereotype.Repository;

import java.util.Collection;

@Repository
public class RdProjectTeamGroupRepositoryImpl implements RdProjectTeamGroupRepository{
    private final RdProjectTeamGroupMapper projectTeamGroupMapper;

    public RdProjectTeamGroupRepositoryImpl(RdProjectTeamGroupMapper projectTeamGroupMapper) {
        this.projectTeamGroupMapper = projectTeamGroupMapper;
    }

    @Override
    public RdProjectTeamGroupEntity getById(Object id) {
        return this.projectTeamGroupMapper.selectById((Long) id);
    }

    @Override
    public void insert(RdProjectTeamGroupEntity data) {
        this.projectTeamGroupMapper.insert(data);
    }

    @Override
    public void update(RdProjectTeamGroupEntity data) {
        this.projectTeamGroupMapper.updateById(data);
    }

    @Override
    public Collection<RdProjectTeamGroupEntity> getTeams(String projectId) {
        LambdaQueryWrapper<RdProjectTeamGroupEntity> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper = lambdaQueryWrapper.eq(RdProjectTeamGroupEntity::getProjectId, projectId);

        return this.projectTeamGroupMapper.selectList(lambdaQueryWrapper);
    }
}
