package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.dtos.SecurityStationCountDTO;
import com.bcxin.tenant.open.domains.entities.RdSecurityStationEntity;
import com.bcxin.tenant.open.domains.entities.RdSecurityStationPersonEntity;
import com.bcxin.tenant.open.domains.mappers.RdSecurityStationPersonMapper;
import com.bcxin.tenant.open.infrastructures.exceptions.NoImplementTenantException;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;
import java.util.Collections;

@Repository
public class RdSecurityStationPersonRepositoryImpl implements RdSecurityStationPersonRepository{

    private final RdSecurityStationPersonMapper securityStationPersonMapper;

    public RdSecurityStationPersonRepositoryImpl(RdSecurityStationPersonMapper securityStationPersonMapper) {
        this.securityStationPersonMapper = securityStationPersonMapper;
    }

    @Override
    public RdSecurityStationPersonEntity getById(Object id) {
        return securityStationPersonMapper.selectById((Long)id);
    }

    @Override
    public void insert(RdSecurityStationPersonEntity data) {
        securityStationPersonMapper.insert(data);
    }

    @Override
    public void update(RdSecurityStationPersonEntity data) {
        securityStationPersonMapper.updateById(data);
    }

    @Override
    public Collection<SecurityStationCountDTO> getCountOfPersonByStationIds(Collection<String> stationIds) {
        if (CollectionUtils.isEmpty(stationIds)) {
            return Collections.EMPTY_LIST;
        }

        return this.securityStationPersonMapper.countByStationIds(stationIds);
    }

    @Override
    public void refreshEmployeeStationByEmployeeIds(Collection<String> employeeIds) {
        this.securityStationPersonMapper.refreshEmployeeStationByEmployeeIds(employeeIds);
    }

    @Override
    public RdSecurityStationPersonEntity getByNoPkId(String id) {
        LambdaQueryWrapper<RdSecurityStationPersonEntity> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(RdSecurityStationPersonEntity::getId, id);

        return this.securityStationPersonMapper.selectOne(lambdaQueryWrapper);
    }
}
