package com.bcxin.tenant.open.domains.repositories;

import com.bcxin.tenant.open.domains.dtos.RdSyncEventWrapperDTO;
import com.bcxin.tenant.open.domains.entities.RdSyncEventEntity;
import com.bcxin.tenant.open.domains.mappers.RdSyncEventMapper;
import com.bcxin.tenant.open.infrastructures.exceptions.NotSupportTenantException;
import org.springframework.stereotype.Repository;

import java.util.Collection;

@Repository
public class RdSyncEventRepositoryImpl implements RdSyncEventRepository {

    private final RdSyncEventMapper syncEventMapper;

    public RdSyncEventRepositoryImpl(RdSyncEventMapper syncEventMapper) {
        this.syncEventMapper = syncEventMapper;
    }

    @Override
    public RdSyncEventEntity getById(Object id) {
        throw new NotSupportTenantException("不支持该操作");
    }

    @Override
    public void insert(RdSyncEventEntity data) {
        throw new NotSupportTenantException("不支持该新增操作");
    }

    @Override
    public void update(RdSyncEventEntity data) {
        throw new NotSupportTenantException("不支持该操作");
    }

    @Override
    public Collection<RdSyncEventEntity> getAllPending(int pageSize) {
        return this.syncEventMapper.getAllPending(pageSize);
    }

    @Override
    public void process(RdSyncEventWrapperDTO eventWrapperDTO) {
        this.syncEventMapper.process(eventWrapperDTO);
    }
}
