package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bcxin.tenant.open.domains.entities.RdSystemExamInfoEntity;
import com.bcxin.tenant.open.domains.mappers.RdSystemExamInfoMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class RdSystemExamInfoRepositoryImpl
        extends RdQueryEntityRepositoryAbstract<RdSystemExamInfoEntity>
        implements RdSystemExamInfoRepository {

    private final RdSystemExamInfoMapper rdSystemExamInfoMapper;

    public RdSystemExamInfoRepositoryImpl(RdSystemExamInfoMapper rdSystemExamInfoMapper) {
        this.rdSystemExamInfoMapper = rdSystemExamInfoMapper;
    }

    @Override
    public Collection<RdSystemExamInfoEntity> getByPage(Collection<String> ids, int pageIndex, int pageSize) {
        LambdaQueryWrapper<RdSystemExamInfoEntity> wrapper = new LambdaQueryWrapper();
        if (!CollectionUtils.isEmpty(ids)) {
            wrapper = wrapper.in(RdSystemExamInfoEntity::getId, ids);
        }

        if (pageIndex <= 0) {
            pageIndex = 1;
        }

        IPage<RdSystemExamInfoEntity> page = new Page<>(pageIndex, pageSize);

        IPage<RdSystemExamInfoEntity> examSiteEntityIPage =
                this.rdSystemExamInfoMapper.selectPage(page, wrapper);

        return examSiteEntityIPage.getRecords();
    }
}
