package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.RdWorkstationEntity;
import com.bcxin.tenant.open.domains.entities.RdWorkstationUserEntity;
import com.bcxin.tenant.open.domains.mappers.RdWorkstationMapper;
import com.bcxin.tenant.open.infrastructures.exceptions.ForbidTenantException;
import org.springframework.stereotype.Repository;

import java.util.Collection;

@Repository
public class RdWorkstationRepositoryImpl implements RdWorkstationRepository {
    private final RdWorkstationMapper workstationMapper;

    public RdWorkstationRepositoryImpl(RdWorkstationMapper workstationMapper) {
        this.workstationMapper = workstationMapper;
    }

    @Override
    public RdWorkstationEntity getById(Object id) {
        return this.workstationMapper.selectById((String) id);
    }

    @Override
    public void insert(RdWorkstationEntity data) {
        throw new ForbidTenantException();
    }

    @Override
    public void update(RdWorkstationEntity data) {
        throw new ForbidTenantException();
    }

    @Override
    public Collection<RdWorkstationEntity> getByEmployeeId(String employeeId) {
        return this.workstationMapper.getByEmployeeId(employeeId);
    }

    @Override
    public long getCountOfStationsByEmployeeId(String employeeId) {
        return this.workstationMapper.getCountOfStationsByEmployeeId(employeeId);
    }
}
