package com.bcxin.tenant.open.domains.repositories;

import com.bcxin.tenant.open.domains.entities.RollCallEmployeeHistoryEntity;
import com.bcxin.tenant.open.domains.mappers.RollCallEmployeeHistoryMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class RollCallEmployeeHistoryRepositoryImpl implements RollCallEmployeeHistoryRepository{

    private final RollCallEmployeeHistoryMapper rollCallEmployeeHistoryMapper;

    public RollCallEmployeeHistoryRepositoryImpl(RollCallEmployeeHistoryMapper rollCallEmployeeHistoryMapper) {
        this.rollCallEmployeeHistoryMapper = rollCallEmployeeHistoryMapper;
    }

    @Override
    public RollCallEmployeeHistoryEntity getById(Object id) {
        return this.rollCallEmployeeHistoryMapper.selectById((Long)id);
    }

    @Override
    public void insert(RollCallEmployeeHistoryEntity data) {
        this.rollCallEmployeeHistoryMapper.insert(data);
    }

    @Override
    public void update(RollCallEmployeeHistoryEntity data) {
        this.rollCallEmployeeHistoryMapper.updateById(data);
    }

    @Override
    public void batchInsert(Collection<RollCallEmployeeHistoryEntity> data) {
        if(!CollectionUtils.isEmpty(data))
        {
            for(RollCallEmployeeHistoryEntity he:data) {
                this.insert(he);
            }
        }
    }
}
