package com.bcxin.tenant.open.domains.repositories;

import com.bcxin.tenant.open.domains.entities.RollCallEntity;
import com.bcxin.tenant.open.domains.mappers.RollCallMapper;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class RollCallRepositoryImpl implements RollCallRepository {
    private final RollCallMapper rollCallMapper;

    public RollCallRepositoryImpl(RollCallMapper rollCallMapper) {
        this.rollCallMapper = rollCallMapper;
    }

    @Override
    public RollCallEntity getById(Object id) {
        return this.rollCallMapper.selectById((Long)id);
    }

    @Override
    public void insert(RollCallEntity data) {
        this.rollCallMapper.insert(data);
    }

    @Override
    public void update(RollCallEntity data) {
        this.rollCallMapper.updateById(data);
    }

    @Override
    public Collection<RollCallEntity> getByIds(Collection<Long> ids) {
        return this.rollCallMapper.selectBatchIds(ids);
    }
}
