package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.dtos.LogoSettingDTO;
import com.bcxin.tenant.open.domains.dtos.ReadInstructionSettingDTO;
import com.bcxin.tenant.open.domains.dtos.SosSettingDTO;
import com.bcxin.tenant.open.domains.entities.TenantAccountEntity;
import com.bcxin.tenant.open.domains.mappers.TenantAccountMapper;
import com.bcxin.tenant.open.infrastructures.enums.DispatchAccountType;
import org.springframework.stereotype.Repository;
import org.springframework.util.CollectionUtils;

import java.util.Collection;

@Repository
public class TenantAccountRepositoryImpl implements TenantAccountRepository{

    private final TenantAccountMapper tenantAccountMapper;

    public TenantAccountRepositoryImpl(TenantAccountMapper tenantAccountMapper) {
        this.tenantAccountMapper = tenantAccountMapper;
    }

    @Override
    public TenantAccountEntity getById(Object id) {
        return tenantAccountMapper.selectById((Long)id);
    }

    @Override
    public void insert(TenantAccountEntity data) {
        this.tenantAccountMapper.insert(data);
    }

    @Override
    public void update(TenantAccountEntity data) {
        this.tenantAccountMapper.updateById(data);
    }

    @Override
    public void SosSetting(SosSettingDTO data) {
        tenantAccountMapper.SosSetting(data);
    }

    @Override
    public void LogoSetting(LogoSettingDTO data) {
        tenantAccountMapper.LogoSetting(data);
    }

    @Override
    public void UpdateReadOperationInstructionStatus(ReadInstructionSettingDTO readInstructionSettingDTO) {
        this.tenantAccountMapper.UpdateReadOperationInstructionStatus(readInstructionSettingDTO);
    }

    @Override
    public TenantAccountEntity getByAccount(DispatchAccountType accountType, String deviceNo) {
        LambdaQueryWrapper<TenantAccountEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper = queryWrapper.eq(TenantAccountEntity::getDeviceNo, deviceNo);
        queryWrapper = queryWrapper.eq(TenantAccountEntity::getDeviceType, accountType.ordinal());

        TenantAccountEntity account = this.tenantAccountMapper.selectOne(queryWrapper);

        return account;
    }
}
