package com.bcxin.tenant.open.domains.repositories;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.bcxin.tenant.open.domains.entities.TenantContentFollowEntity;
import com.bcxin.tenant.open.domains.entities.TenantEmployeeAttendanceEntity;
import com.bcxin.tenant.open.domains.mappers.TenantContentFollowMapper;
import com.bcxin.tenant.open.infrastructures.enums.ContentFollowType;
import org.springframework.stereotype.Repository;

@Repository
public class TenantContentFollowRepositoryImpl implements TenantContentFollowRepository {
    private final TenantContentFollowMapper tenantContentFollowMapper;

    public TenantContentFollowRepositoryImpl(TenantContentFollowMapper tenantContentFollowMapper) {
        this.tenantContentFollowMapper = tenantContentFollowMapper;
    }

    @Override
    public TenantContentFollowEntity getById(Object id) {
        return this.tenantContentFollowMapper.selectById((Long) id);
    }

    @Override
    public void insert(TenantContentFollowEntity data) {
        this.tenantContentFollowMapper.insert(data);
    }

    @Override
    public void update(TenantContentFollowEntity data) {
        this.tenantContentFollowMapper.updateById(data);
    }

    @Override
    public void upset(TenantContentFollowEntity data) {
        this.tenantContentFollowMapper.upset(data);
    }

    @Override
    public TenantContentFollowEntity findByUniqueValue(ContentFollowType followType,
                                                       String contentFollowId, String deviceNo) {
        LambdaQueryWrapper<TenantContentFollowEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper = queryWrapper.eq(TenantContentFollowEntity::getFollowType, followType.ordinal());
        queryWrapper = queryWrapper.eq(TenantContentFollowEntity::getContentFollowId, contentFollowId);
        queryWrapper = queryWrapper.eq(TenantContentFollowEntity::getDeviceNo, deviceNo);
        TenantContentFollowEntity data = this.tenantContentFollowMapper.selectOne(queryWrapper);

        return data;
    }
}
