package com.bcxin.tenant.open.domains.repositories;

import com.bcxin.tenant.open.domains.entities.TenantWarnContentEntity;
import com.bcxin.tenant.open.domains.mappers.TenantWarnContentMapper;
import com.bcxin.tenant.open.infrastructures.exceptions.NotSupportTenantException;
import org.springframework.stereotype.Repository;

@Repository
public class TenantWarnContentRepositoryImpl implements TenantWarnContentRepository{

    private final TenantWarnContentMapper tenantWarnContentMapper;

    public TenantWarnContentRepositoryImpl(TenantWarnContentMapper tenantWarnContentMapper) {
        this.tenantWarnContentMapper = tenantWarnContentMapper;
    }

    @Override
    public TenantWarnContentEntity getById(Object id) {
        throw new NotSupportTenantException("不支持该修改操作");
    }

    @Override
    public void insert(TenantWarnContentEntity data) {
        this.tenantWarnContentMapper.customInsert(data);
    }

    @Override
    public void update(TenantWarnContentEntity data) {
        throw new NotSupportTenantException("不支持该修改操作");
    }
}
