package com.bcxin.tenant.open.domains.repositories;

import com.bcxin.tenant.open.domains.entities.UserPurseEntity;
import com.bcxin.tenant.open.domains.entities.UserPurseTransactionEntity;
import com.bcxin.tenant.open.domains.mappers.UserPurseMapper;
import com.bcxin.tenant.open.domains.mappers.dtos.UserPurseUpdateDTO;
import com.bcxin.tenant.open.infrastructures.exceptions.ForbidTenantException;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.stream.Collectors;

@Repository
public class UserPurseRepositoryImpl implements UserPurseRepository  {
    private final UserPurseMapper userPurseMapper;

    public UserPurseRepositoryImpl(UserPurseMapper userPurseMapper) {
        this.userPurseMapper = userPurseMapper;
    }

    @Override
    public UserPurseEntity getById(Object id) {
        return this.userPurseMapper.selectById((String)id);
    }

    @Override
    public void insert(UserPurseEntity data) {
        throw new ForbidTenantException();
    }

    @Override
    public void update(UserPurseEntity data) {
        throw new ForbidTenantException();
    }

    @Override
    public void addTransactions(Collection<UserPurseTransactionEntity> entities) {
        Collection<String> userPurseIds =
                entities.stream().map(ii -> ii.getUserPurseId())
                        .distinct().collect(Collectors.toList());

        Collection<UserPurseUpdateDTO> userPurseUpdateDTOS =
                userPurseIds.stream().map(ii -> {
                    UserPurseUpdateDTO userPurseUpdateDTO = UserPurseUpdateDTO.create(
                            ii,
                            entities.stream().filter(ix -> ix.getUserPurseId().equalsIgnoreCase(ii)).collect(Collectors.toList())
                    );

                    return userPurseUpdateDTO;
                }).collect(Collectors.toList());

        for (UserPurseUpdateDTO ii : userPurseUpdateDTOS) {
            this.userPurseMapper.updatePoints(ii);
        }
    }
}
